//-----------------------------------------------------------------------------
//    Package Definition
//-----------------------------------------------------------------------------
package uicc.usim.test.toolkit.api_2_tkr_ievs;

//-----------------------------------------------------------------------------
//  Imports
//-----------------------------------------------------------------------------
import org.etsi.scp.wg3.uicc.jcapi.userinterface.*;
import org.etsi.scp.wg3.uicc.jcapi.userclass.*;
import org._3gpp.ct.wg6.usim.jcapi.userclass.*;
import org._3gpp.ct.wg6.usim.jcapi.userinterface.*;

public class Test_Api_2_Tkr_Ievs extends UiccTestModel {

    static final String CAP_FILE_PATH = "uicc/usim/test/toolkit/api_2_tkr_ievs";
    static final String CLASS_AID_1 = "A0000000 871005FF FFFFFF89 20010001";
    static final String APPLET_AID_1 = "A0000000 871005FF FFFFFF89 20010102";
    
      
    private USimAPITestCardService test;
    APDUResponse response;
      
          
    public Test_Api_2_Tkr_Ievs() {
        test = USimAPITestCardService.getTheUSimTestCardService();
    }
    
    public boolean run() {
        boolean result = false;
        
        // test script
        test.reset();
        test.terminalProfileSession("1719");

        // Install package
        test.loadPackage(CAP_FILE_PATH);
            
        // Install Applet
        test.installApplet(CAP_FILE_PATH, CLASS_AID_1, APPLET_AID_1, 
                           "8008" + // TLV UICC Toolkit application specific parameters
                           "01" +   // V Priority Level
                           "00" +   // V Max. number of timers
                           "00" +   // V Maximum text length for a menu entry
                           "00" +   // V Maximum number of menu entries                              
                           "00" +   // V Maximum number of channels 
                           "00" +   // LV Minimum Security Level field
                           "00" +   // LV TAR Value(s) 
                           "00" );  // V Maximum number of services
        
        test.reset();
        test.terminalProfileSession("1719");
        
        /*********************************************************************/
        /** Testcase 1 Test that events are not set                          */
        /** Testcase 2 Setting events                                        */
        /*********************************************************************/      
        //Trigger applet
        test.envelopeEventDownloadUserActivity();
       
        /***********************************/        
        /**         Check results          */        
        /***********************************/         
        
        // Select applet
        response = test.selectApplication(APPLET_AID_1);
        result = response.checkData("10" + APPLET_AID_1 + 
                                    "02CCCC");
    
      
        test.reset();
        test.terminalProfileSession("1719");    
        // Delete Applet 
        test.deleteApplet(APPLET_AID_1);
        // Delete Package
        test.deletePackage(CAP_FILE_PATH);   
        
        return result;
    }
}   
