//-----------------------------------------------------------------------------
//Test_Ufw_Mha_Rent.java
//-----------------------------------------------------------------------------

//-----------------------------------------------------------------------------
//Package Definition
//-----------------------------------------------------------------------------
package uicc.usim.test.usatframework.ufw_mha_rent;

//-----------------------------------------------------------------------------
//Imports
//-----------------------------------------------------------------------------
import org.etsi.scp.wg3.uicc.jcapi.userinterface.*;
import org.etsi.scp.wg3.uicc.jcapi.userclass.*;
import org._3gpp.ct.wg6.usim.jcapi.userclass.*;
import org._3gpp.ct.wg6.usim.jcapi.userinterface.*;

public class Test_Ufw_Mha_Rent extends UiccTestModel {


    static final String CAP_FILE_PATH = "uicc/usim/test/usatframework/ufw_mha_rent";
    private final String CLASS_AID_1 = "A0000000 871005FF FFFFFF89 50010001";
    private final String APPLET_AID_1 = "A0000000 871005FF FFFFFF89 50010102";
   
 
    private static String     TERMINAL_PROFILE  = "1E098000 00000000 01";
  
  
    private USimAPITestCardService test;
   
    /** contains the response from the executed command */
    private APDUResponse      response      = null;
    /** stores the test result */
    private boolean         result      = false;

  /**
   * 
   */
    public Test_Ufw_Mha_Rent() {
        test = USimAPITestCardService.getTheUSimTestCardService();
    }
    /**
     * Installs the applet, runs the tests and checks the test result.
     */
    public boolean run(){
        // test script
        test.reset();
        test.terminalProfileSession(TERMINAL_PROFILE);
  
        // Install Applet
        test.loadPackage(CAP_FILE_PATH);
        test.installApplet(CAP_FILE_PATH, CLASS_AID_1, APPLET_AID_1, 
                                "8008" + // TLV UICC Toolkit application specific parameters
                                "01" +   // V Priority Level
                                "00" +   // V Max. number of timers
                                "00" +   // V Maximum text length for a menu entry
                                "00" +   // V Maximum number of menu entries                              
                                "00" +   // V Maximum number of channels 
                                "00" +   // LV Minimum Security Level field
                                "00" +   // LV TAR Value(s) 
                                "00" );  // V Maximum number of services        
          
          
        // 1- Send envelope unrecognized to trigger Applet1
        response = test.unrecognizedEnvelope();
                
        //Display Text 
        result = response.checkSw("9114");

        // Send envelope Event Formatted SMS PP UPD to trigger Applet1 again
        
        //select EF SMS
        test.selectFile("3F00");//Select MF
        test.selectFile("7F10");//Select DF Telecom
        test.selectFile("6F3C");//Select EF SMS
        //update first record
        response = test.updateRecord("01", "04", "03028100 40088155 6677887F F6001129" +
                                     "12000004 14027000 000F0D00 00000050" +     
                                     "01010000 00000100 01FFFFFF FFFFFFFF" +     
                                     "FFFFFFFF FFFFFFFF FFFFFFFF FFFFFFFF" +     
                                     "FFFFFFFF FFFFFFFF FFFFFFFF FFFFFFFF" +     
                                     "FFFFFFFF FFFFFFFF FFFFFFFF FFFFFFFF" +     
                                     "FFFFFFFF FFFFFFFF FFFFFFFF FFFFFFFF" +     
                                     "FFFFFFFF FFFFFFFF FFFFFFFF FFFFFFFF" +     
                                     "FFFFFFFF FFFFFFFF FFFFFFFF FFFFFFFF" +     
                                     "FFFFFFFF FFFFFFFF FFFFFFFF FFFFFFFF" +     
                                     "FFFFFFFF FFFFFFFF FFFFFFFF FFFFFFFF");     
                                     
        response = test.fetch("14");
        result &= response.checkData("D0128103 01218082 0281028D 07045445" +
                                     "58542031");                
        response = test.terminalResponse("81030121 80820282 81030100");            
          
          
                              
        // 2- Send envelope unrecognized to trigger Applet1
        response = test.unrecognizedEnvelope();
               
        //Display Text 
        result &= response.checkSw("9114");
        
        // Send envelope Event Unformatted SMS PP UPD to trigger Applet1 again
        
        //select EF SMS
        test.selectFile("3F00");//Select MF
        test.selectFile("7F10");//Select DF Telecom
        test.selectFile("6F3C");//Select EF SMS
        //update second record
        response = test.updateRecord("02", "04", "03028100 00088155 6677887F F6001129" +
                                     "12000004 10AAAAAA AAAAAAAA AAAAAAAA" +     
                                     "AAAAAAAA AAFFFFFF FFFFFFFF FFFFFFFF" +     
                                     "FFFFFFFF FFFFFFFF FFFFFFFF FFFFFFFF" +     
                                     "FFFFFFFF FFFFFFFF FFFFFFFF FFFFFFFF" +     
                                     "FFFFFFFF FFFFFFFF FFFFFFFF FFFFFFFF" +     
                                     "FFFFFFFF FFFFFFFF FFFFFFFF FFFFFFFF" +     
                                     "FFFFFFFF FFFFFFFF FFFFFFFF FFFFFFFF" +     
                                     "FFFFFFFF FFFFFFFF FFFFFFFF FFFFFFFF" +     
                                     "FFFFFFFF FFFFFFFF FFFFFFFF FFFFFFFF" +     
                                     "FFFFFFFF FFFFFFFF FFFFFFFF FFFFFFFF");   
                                     
        response = test.fetch("14");
        result &= response.checkData("D0128103 01218082 0281028D 07045445" +
                                     "58542031");                
        response = test.terminalResponse("81030121 80820282 81030100");            
          
          
                              
        // 3- Send envelope unrecognized to trigger Applet1
        response = test.unrecognizedEnvelope();       
        
        //Display Text 
        result &= response.checkSw("9114");
        
        // Send envelope Event Mo Short Message Control by Sim to trigger Applet1 again
        response = test.envelopeMoShortMessageControl(); 
                                     
        response = test.fetch("14");
        result &= response.checkData("D0128103 01218082 0281028D 07045445" +
                                     "58542031");                
        response = test.terminalResponse("81030121 80820282 81030100");            
          
          

        // 4- Send envelope unrecognized to trigger Applet1
        response = test.unrecognizedEnvelope();
        
        //Display Text 
        result &= response.checkSw("9114");
        
        // Send envelope Event Formatted SMS PP ENV to trigger Applet1 again
        response = test.envelopeSmsPp("8B254008 81556677 887FF600 11291200" +
                                      "00041402 7000000F 0D080000 00500101" +
                                      "00000000 010001"); 
                                     
        response = test.fetch("14");
        result &= response.checkData("D0128103 01218082 0281028D 07045445" +
                                     "58542031");                
        response = test.terminalResponse("81030121 80820282 81030100");            
          
        
        // 5- Send envelope unrecognized to trigger Applet1
        response = test.unrecognizedEnvelope();
        
        //Display Text 
        result &= response.checkSw("9114");
        
        // Send envelope Event Unformatted SMS PP ENV to trigger Applet1 again
        response = test.envelopeSmsPp("8B110008 81556677 887FF600 11291200" + 
                                      "000400"); 
                                     
        response = test.fetch("14");
        result &= response.checkData("D0128103 01218082 0281028D 07045445" +
                                     "58542031");                
        response = test.terminalResponse("81030121 80820282 81030100");            
          
        
        // 6- Send envelope unrecognized to trigger Applet1
        response = test.unrecognizedEnvelope();
        
        //Display Text 
        result &= response.checkSw("9114");
        
        // Send envelope Event Formatted SMS CB to trigger Applet1 again
        response = test.envelopeCellBroadcast("8C58A750 1093F611 000F0D00 00000050"
                                            + "01010000 00000100 01000000 00000000"
                                            + "00000000 00000000 00000000 00000000"
                                            + "00000000 00000000 00000000 00000000"
                                            + "00000000 00000000 00000000 00000000"
                                            + "00000000 00000000 0000"); 
                                     
        response = test.fetch("14");
        result &= response.checkData("D0128103 01218082 0281028D 07045445" +
                                     "58542031");                
        response = test.terminalResponse("81030121 80820282 81030100");            
          
        // 7- Send envelope unrecognized to trigger Applet1
        response = test.unrecognizedEnvelope();
        
        //Display Text 
        result &= response.checkSw("9114");
        
       // Send envelope Event Unformatted SMS CB to trigger Applet1 again
        response = test.envelopeCellBroadcast("8C58C011 1000F611 00000000 00000000" +
                                              "00000000 00000000 00000000 00000000" +
                                              "00000000 00000000 00000000 00000000" +
                                              "00000000 00000000 00000000 00000000" +
                                              "00000000 00000000 00000000 00000000" +
                                              "00000000 00000000 0000"); 
                                     
        response = test.fetch("14");
        result &= response.checkData("D0128103 01218082 0281028D 07045445" +
                                     "58542031");                
        response = test.terminalResponse("81030121 80820282 81030100");            
          
        
        
        
        response = test.selectApplication(APPLET_AID_1);
        result &=  response.checkData("10" +APPLET_AID_1 +
                          "15CCCCCC CCCCCCCC CCCCCCCC CCCCCCCC" +
                          "CCCCCCCC CCCC");
      
        //  delete applet and package
        test.reset();
        test.terminalProfileSession(TERMINAL_PROFILE);
        test.deleteApplet(APPLET_AID_1);
        
        test.deletePackage(CAP_FILE_PATH);
          
        return result;
  }
  
  
}